package cn.wch.ch34xuartdriver;

import java.io.ByteArrayInputStream;   
import java.io.ByteArrayOutputStream;   
import java.io.IOException;   
import java.io.ObjectInputStream;   
import java.io.ObjectOutputStream;   
import java.io.Serializable;   
   
/*  
 * 转锟斤拷锟斤拷锟斤拷锟斤拷  
 *   
 * @author HFH  
 */   
public class CconverUtils {   
   
    private CconverUtils() {   
   
    }   
   
    public final static char[] BCD_2_ASC = "0123456789abcdef".toCharArray();   
   
    /**  
     * @param args  
     */   
  
   
    /**  
     * 锟斤拷锟街凤拷转锟斤拷为锟街节ｏ拷锟斤拷十锟斤拷锟斤拷锟斤拷址锟阶拷纸锟斤拷锟斤拷锟绞憋拷锟�  
     *   
     * @author hfh, 2007-10-25  
     *   
     * @param achar  
     * @return  
     */   
    private static byte char2byte(char achar) {   
        byte b = (byte) "0123456789ABCDEF".indexOf(Character.toUpperCase(achar));   
        return b;   
    }   
   
    /**  
     * 锟斤拷16锟斤拷锟斤拷锟街凤拷转锟斤拷锟斤拷锟街斤拷锟斤拷锟斤拷  
     *   
     * @author hfh, 2007-10-25  
     *   
     * @param hexStr  
     * @return  
     */   
    public static final byte[] hexStr2Bytes(String hexStr) {   
    	hexStr = hexStr.replace(" ", ""); //tang
    	int len = (hexStr.length() / 2);   
        byte[] result = new byte[len];   
        char[] achar = hexStr.toCharArray();   
        for (int i = 0; i < len; i++) {   
            int pos = i * 2;   
            result[i] = (byte) (char2byte(achar[pos]) << 4 | char2byte(achar[pos + 1]));   
        }   
        return result;   
    }   
   
    /**  
     * 锟斤拷锟街斤拷锟斤拷锟斤拷转锟斤拷锟斤拷16锟斤拷锟斤拷锟街凤拷  
     *   
     * @author hfh, 2007-10-25  
     *   
     * @param bArray  
     * @return  
     */   
    public static final String bytes2HexStr(byte[] bArray) {   
        StringBuffer sb = new StringBuffer(bArray.length);   
        String sTemp;   
        for (int i = 0; i < bArray.length; i++) {   
            sTemp = Integer.toHexString(0xFF & bArray[i]);   
            if (sTemp.length() < 2)   
                sb.append(0);   
            sb.append(sTemp.toUpperCase());   
        }   
        return sb.toString();   
    }   
   
    /**  
     * 锟斤拷锟街斤拷锟斤拷锟斤拷转锟斤拷锟斤拷16锟斤拷锟斤拷锟街凤拷  
     *   
     * 锟斤拷锟街节硷拷锟斤拷指锟斤拷锟街革拷锟斤拷指锟�,锟斤拷锟节查看  
     *   
     * @author hfh, 2007-10-25  
     *   
     * @param bArray  
     * @param delimiter  
     * @return  
     */   
    public static final String bytes2HexStr(byte[] bArray, String delimiter) {   
        StringBuffer sb = new StringBuffer(bArray.length);   
        String sTemp;   
        for (int i = 0; i < bArray.length; i++) {   
            sTemp = Integer.toHexString(0xFF & bArray[i]);   
            if (sTemp.length() < 2)   
                sb.append(0);   
   
            sb.append(sTemp.toUpperCase());   
   
            // 嵌锟斤拷指锟斤拷锟�    
            if (i < bArray.length - 1)   
                sb.append(delimiter);   
        }   
        return sb.toString();   
    }   
   
    /**  
     * 锟斤拷锟街斤拷锟斤拷锟斤拷转锟斤拷为锟斤拷锟斤拷  
     *  
     * @author hfh, 2007-10-25  
     *  
     * @param bytes  
     * @return  
     * @throws IOException  
     * @throws ClassNotFoundException  
     */   
    public static final Object bytes2Object(byte[] bytes) throws IOException, ClassNotFoundException {   
        ByteArrayInputStream in = new ByteArrayInputStream(bytes);   
        ObjectInputStream oi = new ObjectInputStream(in);   
        Object o = oi.readObject();   
        oi.close();   
        return o;   
    }   
   
    /**  
     * 锟斤拷锟斤拷锟斤拷锟叫伙拷锟斤拷锟斤拷转锟斤拷锟斤拷锟街斤拷锟斤拷锟斤拷  
     *  
     * @author hfh, 2007-10-25  
     *  
     * @param s  
     * @return  
     * @throws IOException  
     */   
    public static final byte[] object2Bytes(Serializable s) throws IOException {   
        ByteArrayOutputStream out = new ByteArrayOutputStream();   
        ObjectOutputStream ot = new ObjectOutputStream(out);   
        ot.writeObject(s);   
        ot.flush();   
        ot.close();   
        return out.toByteArray();   
    }   
   
    /**  
     * 锟斤拷锟斤拷锟斤拷锟叫伙拷锟斤拷锟斤拷转锟斤拷锟斤拷16锟斤拷锟斤拷锟街凤拷  
     *  
     * @author hfh, 2007-10-25  
     *  
     * @param s  
     * @return  
     * @throws IOException  
     */   
    public static final String object2HexStr(Serializable s) throws IOException {   
        return bytes2HexStr(object2Bytes(s));   
    }   
   
    /**  
     * 锟斤拷16锟斤拷锟斤拷锟街凤拷转锟斤拷锟缴讹拷锟斤拷  
     *  
     * @author hfh, 2007-10-25  
     *  
     * @param hexStr  
     * @return  
     * @throws IOException  
     * @throws ClassNotFoundException  
     */   
    public static final Object hexStr2Object(String hexStr) throws IOException, ClassNotFoundException {   
        return bytes2Object(CconverUtils.hexStr2Bytes(hexStr));   
    }   
   
    /**  
     * BCD锟斤拷转为10锟斤拷锟狡达拷(锟斤拷锟斤拷锟斤拷锟斤拷锟街达拷)  
     *  
     * @author hfh, 2007-10-25  
     *  
     * @param bytes  
     * @return  
     */   
    public static String bcd2DigitStr(byte[] bytes) {   
        StringBuffer temp = new StringBuffer(bytes.length * 2);   
   
        for (int i = 0; i < bytes.length; i++) {   
            temp.append((byte) ((bytes[i] & 0xf0) >>> 4));   
            temp.append((byte) (bytes[i] & 0x0f));   
        }   
        return temp.toString().substring(0, 1).equalsIgnoreCase("0") ? temp.toString().substring(1) : temp   
                .toString();   
    }   
   
    /**  
     * 10锟斤拷锟狡达拷转为BCD锟斤拷  
     *  
     * @author hfh, 2007-10-25  
     *  
     * @param asc  
     * @return  
     */   
    public static byte[] str2Bcd(String asc) {   
        int len = asc.length();   
        int mod = len % 2;   
   
        if (mod != 0) {   
            asc = "0" + asc;   
            len = asc.length();   
        }   
   
        byte abt[] = new byte[len];   
        if (len >= 2) {   
            len = len / 2;   
        }   
   
        byte bbt[] = new byte[len];   
        abt = asc.getBytes();   
        int j, k;   
   
        for (int p = 0; p < asc.length() / 2; p++) {   
            if ((abt[2 * p] >= '0') && (abt[2 * p] <= '9')) {   
                j = abt[2 * p] - '0';   
            } else if ((abt[2 * p] >= 'a') && (abt[2 * p] <= 'z')) {   
                j = abt[2 * p] - 'a' + 0x0a;   
            } else {   
                j = abt[2 * p] - 'A' + 0x0a;   
            }   
   
            if ((abt[2 * p + 1] >= '0') && (abt[2 * p + 1] <= '9')) {   
                k = abt[2 * p + 1] - '0';   
            } else if ((abt[2 * p + 1] >= 'a') && (abt[2 * p + 1] <= 'z')) {   
                k = abt[2 * p + 1] - 'a' + 0x0a;   
            } else {   
                k = abt[2 * p + 1] - 'A' + 0x0a;   
            }   
   
            int a = (j << 4) + k;   
            byte b = (byte) a;   
            bbt[p] = b;   
        }   
        return bbt;   
    }   
   
    /**  
     * BCD锟斤拷转ASC锟斤拷  
     *  
     * @author hfh, 2007-10-25  
     *  
     * @param bytes  
     * @return  
     */   
    public static String bcd2Asc(byte[] bytes) {   
        StringBuffer temp = new StringBuffer(bytes.length * 2);   
   
        for (int i = 0; i < bytes.length; i++) {   
            int h = ((bytes[i] & 0xf0) >>> 4);   
            int l = (bytes[i] & 0x0f);   
            temp.append(BCD_2_ASC[h]).append(BCD_2_ASC[l]);   
        }   
        return temp.toString();   
    }   
       
    /**  
     * 锟斤拷锟街凤拷转锟斤拷为锟斤拷锟斤拷值  
     *  
     * @author hfh, 2007-10-26  
     *  
     * @param value  
     * @return  
     */   
    public static boolean str2boolean(String value) {   
        return value.equalsIgnoreCase("true") || value.equals("1");   
    }   
       
}   
